import asyncio
import websockets

# Crée un dictionnaire pour stocker les connexions WebSocket par adresse IP
websocket_connections = {}
master = None

async def echo(websocket, path):
    global master
    print(websocket.remote_address[0])
    client_ip = websocket.remote_address[0]
    websocket_connections[client_ip] = websocket

    async for message in websocket:
        if message[0] == '#':
            master = client_ip
            tasks = []
            print(f"Il y a {len(websocket_connections)}")
            for client_ip, ws in websocket_connections.items():
                if client_ip != master:
                    tasks.append(determine_response(ws, "search 74d181ce69fa53e60fb588719cc404e1 a 9999"))
            await asyncio.gather(*tasks)  # Attendre que toutes les coroutines se terminent
            await websocket.send("Vous êtes le maître.")

async def determine_response(ws, requete):
    # Fonction de détermination de réponse en fonction du message reçu
    print(f"ici")
    await ws.send(requete)
    reponse = await ws.recv()
    print(reponse)

async def main():
    async with websockets.serve(echo, "0.0.0.0", 16688):
        await asyncio.Future()  # Gardez le serveur actif indéfiniment

if __name__ == "__main__":
    asyncio.run(main())
